#! /usr/bin/python
# coding: Utf-8

import os, sys, gtk, signal, random, dbus.mainloop.glib

icondir = "/usr/share/pixmaps/"
basedir = "/usr/lib/xscreensaver/"
lastpid,lockuuid,lockpath,keyitems = -1,None,None,{}

xsavers = [ ("boxed",),
            ("compass",),
            ("coral",),
            ("fireworkx", "-maxlife", "42"),
            ("glforestfire", "-trees", "42"),
            ("glhanoi",),
            ("glmatrix",),
            ("glplanet",),
            ("glschool",),
            ("glsnake",),
            ("grav",),
            ("hyperball",),
            ("lightning",),
            ("lockward",),
            ("maze",),
            ("molecule",),
            ("photopile", "-no-polaroid", "-count", "7"),
            ("glforestfire", "-rain", "-trees", "42"),
            ("polyhedra",),
            ("polytopes",),
            ("stonerview",),
            ("tangram",),
            ("whirlwindwarp",),
            ("wormhole",) ]

# Repérage d'une précédente instance…
f = os.popen("ps -ef | grep "+sys.argv[0]+" | grep -v grep | tr -s ' '")
lines = f.readlines()
f.close()
for line in lines:
    line = line.replace("\n", "").split(" ")
    if line[1] == str(os.getpid()): continue
    if line[7].endswith("python") and line[8] == sys.argv[0]:
        os.system("kill -TERM " + line[1])
        sys.exit(0)

# Arrête proprement.
def _stop(*args):
    if lastpid != -1:
        os.system("kill -15 "+str(lastpid))
    gtk.main_quit()
    sys.exit(0)
signal.signal(signal.SIGTERM, _stop)

# Verrouille.
def _lock():
    hbox.hide()
    win.stick()
    win.present()
    win.fullscreen()
    gtk.gdk.pointer_grab(win.window)
    gtk.gdk.keyboard_grab(win.window)

# Déverrouille.
def _unlock():
    gtk.gdk.keyboard_ungrab()
    gtk.gdk.pointer_ungrab()
    win.unfullscreen()
    win.unstick()
    hbox.show()

# Choisis une clef pour verrouiller.
def _choose_key(item, path, uuid):
    for child in menu.get_children()[1:]:
        if child != item: # On remet l'icône de base.
            child.get_image().set_from_pixbuf(diskicon)
    item.get_image().set_from_pixbuf(lockicon)
    global lockpath, lockuuid
    lockpath,lockuuid = path,uuid

# Réagit au branchement.
def _devadd(path):
    device = dbus.Interface(bus.get_object("org.freedesktop.UDisks", path),
                                           "org.freedesktop.UDisks.Device")
    props = dbus.Interface(device, dbus.PROPERTIES_IFACE)
    uuid = props.Get("org.freedesktop.UDisks.Device", "IdUuid")
    if uuid == lockuuid:
        icon = lockicon
        _unlock()
    else: icon = diskicon
    label = props.Get("org.freedesktop.UDisks.Device", "IdLabel")
    if label == "": label = uuid
    parent = path # Voyons si ça se démonte.
    while parent[-1].isdigit():
        parent = parent[:-1]
    if parent == path: return # Pas la peine.
    if len(os.path.split(parent)[1]) < 3: return # Pas un disque dur.
    device = dbus.Interface(bus.get_object("org.freedesktop.UDisks", parent),
                                           "org.freedesktop.UDisks.Device")
    props = dbus.Interface(device, dbus.PROPERTIES_IFACE)
    if (props.Get("org.freedesktop.UDisks.Device", "DeviceIsRemovable")!=1):
        return # Donc, non, on laisse tomber.
    item = gtk.ImageMenuItem(label)
    keyitems.setdefault(path, item)
    item.connect("activate", _choose_key, path, uuid)
    item.set_image(gtk.image_new_from_pixbuf(icon))
    menu.get_children()[0].hide()
    menu.append(item)
    item.show_all()

# Réagit au débranchement.
def _devrem(path):
    if path == lockpath: _lock()
    if keyitems.has_key(path):
        menu.remove(keyitems.pop(path))
        if len(menu.get_children()) == 1:
            menu.get_children()[0].show()

# Active ou désactive l'item.
def _toggle_select(item, event=None):
    for child in mbar.get_children():
        child.set_state(gtk.STATE_NORMAL)
    item.set_state(gtk.STATE_PRELIGHT)
    return True

# Affiche ou masque le panel.
def _show_saver(item, state, num):
    if item.get_state() == gtk.STATE_PRELIGHT:
        global lastpid
        if lastpid != -1:
            os.system("kill -15 "+str(lastpid))
        lastpid = _launch_saver(num)

# Lance un écran de veille.
def _launch_saver(num):
    pid = os.fork()
    if pid == 0:
        os.execvp(os.path.join(basedir, xsavers[num][0]),
            xsavers[num]+("-window-id", str(int(sock.get_id()))))
    else: return pid

# Change aléatoirement.
def _random(item, event):
    for child in mbar.get_children():
        child.set_state(gtk.STATE_NORMAL)
    if lastpid != -1:
            os.system("kill -15 "+str(lastpid))
    random.choice(mbar.get_children()).set_state(gtk.STATE_PRELIGHT)

# Désactive l'élément.
def _unsel(item, state):
    if item.get_state() != gtk.STATE_NORMAL:
        item.set_state(gtk.STATE_NORMAL)

# Réagit au clavier.
def _keypress(window, event):
    if event.keyval == 65307:
        _stop() # Échap, on ferme.

# Connexion à DBus et branchements.
dbus.mainloop.glib.DBusGMainLoop(set_as_default=True)
bus = dbus.SystemBus() # Et on récupère l'interface requise…
udisk = bus.get_object("org.freedesktop.UDisks", "/org/freedesktop/UDisks")
interface = dbus.Interface(udisk, "org.freedesktop.UDisks")
interface.connect_to_signal("DeviceRemoved", _devrem)
interface.connect_to_signal("DeviceAdded", _devadd)

# Création de la fenêtre…
win = gtk.Window()
win.parse_geometry("800x600")
win.connect("destroy", _stop)
win.connect("key-press-event", _keypress)
vbox = gtk.VBox(False, 0)
win.add(vbox)
theme = gtk.icon_theme_get_default()
win.set_icon(theme.load_icon("lock", 48, gtk.ICON_LOOKUP_USE_BUILTIN))
win.set_title("Verrouillage USB")
hbox = gtk.HBox(False, 0)
mbar = gtk.MenuBar()
hbox.pack_start(mbar, False, False)
menu = gtk.Menu()
item = gtk.MenuItem("Clef")
item.set_submenu(menu)
mbar.append(item)
mbar = gtk.MenuBar()
hbox.pack_end(mbar, True, True)
item = gtk.ImageMenuItem("")
icon = theme.load_icon("applications-games", 16, gtk.ICON_LOOKUP_USE_BUILTIN)
item.set_image(gtk.image_new_from_pixbuf(icon))
item.connect("button-press-event", _random)
item.connect("state-changed", _unsel)
style = gtk.RcStyle()
style.xthickness = 0
style.ythickness = 0
item.modify_style(style)
item.set_size_request(6, 24)
mbar.append(item)
mbar = gtk.MenuBar()
hbox.pack_start(mbar, False, False)
vbox.pack_start(hbox, False, False)
sock = gtk.Socket()
sock.modify_bg(gtk.STATE_NORMAL, gtk.gdk.color_parse("#000000"))
vbox.pack_end(sock, True, True)
icon = theme.load_icon("screensaver", 16, gtk.ICON_LOOKUP_USE_BUILTIN)
for i in range(len(xsavers)):
    item = gtk.ImageMenuItem("")
    fname = os.path.join(icondir, xsavers[i][0]+".png")
    if os.path.exists(fname):
        image = gtk.image_new_from_file(fname)
    else: image = gtk.image_new_from_pixbuf(icon)
    item.connect("button-press-event", _toggle_select)
    item.connect("state-changed", _show_saver, i)
    item.set_image(image)
    style = gtk.RcStyle()
    style.xthickness = 0
    style.ythickness = 0
    item.modify_style(style)
    item.set_size_request(6, 24)
    mbar.append(item)
diskicon=theme.load_icon("drive-removable-media",16,gtk.ICON_LOOKUP_USE_BUILTIN)
lockicon = theme.load_icon("unlocked", 16, gtk.ICON_LOOKUP_USE_BUILTIN)
item = gtk.ImageMenuItem("Aucune clef")
item.set_image(gtk.image_new_from_pixbuf(diskicon))
item.get_child().set_markup("<i>Aucune clef</i>")
item.set_sensitive(False)
menu.append(item)
win.show_all()
random.choice(mbar.get_children()).set_state(gtk.STATE_PRELIGHT)
for path in interface.EnumerateDevices(): _devadd(path)
gtk.main()
